import datetime
import tkinter

def formatLine(response):
    line = response.split()
    txt = (line[0]).decode('utf-8').zfill(2)+'.'+(line[1]).decode('utf-8').zfill(2)+'.'+(line[2]).decode('utf-8')+' '
    txt = txt + (line[3]).decode('utf-8').zfill(2)+':'+(line[4]).decode('utf-8').zfill(2)+' '
    txt = txt + (line[5]).decode('utf-8').zfill(5)+' '+(line[7]).decode('utf-8').zfill(5)+' '+(line[6]).decode('utf-8').zfill(6)+' '
    return txt

def line2date(strg):
    dt=datetime.datetime.strptime(strg[0:16], "%d.%m.%Y %H:%M")
    return dt

def line2temp(strg):
    t=strg[17:22]
    return t

def line2feuchte(strg):
    f=strg[23:28]
    return f

def line2druck(strg):
    d=strg[29:35]
    return d

def line2beobachtung(strg):
    b=strg[36:38]
    if b == '\n': b=''
    return b

def make_patch_spines_invisible(ax):
    ax.set_frame_on(True)
    ax.patch.set_visible(False)
    for sp in ax.spines.values():
        sp.set_visible(False)
        
def get_bit(byteval,idx):
    return ((byteval&(1<<idx))!=0);
        
def decodeBeschreibungStr(n):
    strg = ""
    if (get_bit(n, 0) and not get_bit(n, 1)): strg = 'Leichter Wind\n'
    if (not get_bit(n, 0) and get_bit(n, 1)): strg = strg + 'Maessiger Wind\n'
    if (get_bit(n, 0) and get_bit(n, 1)): strg = strg + 'Starker Wind\n'
    if (not get_bit(n, 0) and not get_bit(n, 1)): strg = strg + 'Kein Wind\n'
    if (get_bit(n, 2) and not get_bit(n, 3)): strg = strg + 'Leichter Regen\n'
    if (not get_bit(n, 2) and get_bit(n, 3)): strg = strg + 'Starker Regen\n'
    if (get_bit(n, 2) and get_bit(n, 3)): strg = strg + 'Schnee\n'
    if (not get_bit(n, 2) and not get_bit(n, 3)): strg = strg + 'Kein Regen/Schnee\n'
    if (get_bit(n, 4) and not get_bit(n, 5)): strg = strg + 'Leicht bewoelkt\n'
    if (not get_bit(n, 4) and get_bit(n, 5)): strg = strg + 'Stark bewoelkt\n'
    if (get_bit(n, 4) and get_bit(n, 5)): strg = strg + 'Bedeckt\n'
    if (not get_bit(n, 4) and not get_bit(n, 5)): strg = strg + 'Wolkenlos\n'
    if (get_bit(n, 6) and not get_bit(n, 7)): strg = strg + 'Gewitter\n'
    if (not get_bit(n, 6) and get_bit(n, 7)): strg = strg + 'Nebel\n'
    if (get_bit(n, 6) and get_bit(n, 7)): strg = strg + 'Schneedecke\n'
    return strg

def decodeBeschreibung(n):
    lst = []
    if (get_bit(n, 0) and not get_bit(n, 1)): lst.append('Leichter Wind')
    if (not get_bit(n, 0) and get_bit(n, 1)): lst.append('Maessiger Wind')
    if (get_bit(n, 0) and get_bit(n, 1)): lst.append('Starker Wind')
    if (not get_bit(n, 0) and not get_bit(n, 1)): lst.append('Kein Wind')
    if (get_bit(n, 2) and not get_bit(n, 3)): lst.append('Leichter Regen')
    if (not get_bit(n, 2) and get_bit(n, 3)): lst.append('Starker Regen')
    if (get_bit(n, 2) and get_bit(n, 3)): lst.append('Schnee')
    if (not get_bit(n, 2) and not get_bit(n, 3)): lst.append('Kein Regen/Schnee')
    if (get_bit(n, 4) and not get_bit(n, 5)): lst.append('Leicht bewoelkt')
    if (not get_bit(n, 4) and get_bit(n, 5)): lst.append('Stark bewoelkt')
    if (get_bit(n, 4) and get_bit(n, 5)): lst.append('Bedeckt')
    if (not get_bit(n, 4) and not get_bit(n, 5)): lst.append('Wolkenlos')
    if (get_bit(n, 6) and not get_bit(n, 7)): lst.append('Gewitter')
    if (not get_bit(n, 6) and get_bit(n, 7)): lst.append('Nebel')
    if (get_bit(n, 6) and get_bit(n, 7)): lst.append('Schneedecke')
    if (not get_bit(n, 6) and not get_bit(n, 7)): lst.append('Keine Besonderheit')
    return lst
        
class CBeschreibungDialog:
    def __init__(self, parent):
        self.top = tkinter.Toplevel(parent)
        self.iWind = tkinter.IntVar()
        self.iWind.set(0)
        self.iRegen = tkinter.IntVar()
        self.iRegen.set(0)
        self.iWolken = tkinter.IntVar()
        self.iWolken.set(0)
        self.iBesonders = tkinter.IntVar()
        self.iBesonders.set(0)
        self.top.title("Wetterbeschreibung")
        self.result = 0
        tkinter.Label(self.top, text="Wind").grid(row=0,column=0, padx=5, pady=10, sticky=tkinter.W);
        tkinter.Radiobutton(self.top, text='Leicht', variable = self.iWind, value = 1, command=self.wind).grid(row=1,column=0,  padx=5, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Maessig', variable = self.iWind, value = 2, command=self.wind).grid(row=2,column=0,  padx=5, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Stark', variable = self.iWind, value = 3, command=self.wind).grid(row=3,column=0,  padx=5, sticky=tkinter.W)
        tkinter.Label(self.top, text="Regen").grid(row=0,column=1, padx=5, pady=10, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Leicht', variable = self.iRegen, value = 1, command=self.regen).grid(row=1,column=1, padx=5, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Stark', variable = self.iRegen, value = 2, command=self.regen).grid(row=2,column=1, padx=5, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Schnee', variable = self.iRegen, value = 3, command=self.regen).grid(row=3,column=1, padx=5, sticky=tkinter.W)
        tkinter.Label(self.top, text="Wolken").grid(row=0,column=2, padx=5, pady=10, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Leicht', variable = self.iWolken, value = 1, command=self.wolken).grid(row=1,column=2, padx=5, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Stark', variable = self.iWolken, value = 2, command=self.wolken).grid(row=2,column=2, padx=5, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Bedeckt', variable = self.iWolken, value = 3, command=self.wolken).grid(row=3,column=2, padx=5, sticky=tkinter.W)
        tkinter.Label(self.top, text="Besonderheiten").grid(row=0,column=3, padx=5, pady=10, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Gewitter', variable = self.iBesonders, value = 1, command=self.besonders).grid(row=1,column=3, padx=5, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Nebel', variable = self.iBesonders, value = 2, command=self.besonders).grid(row=2,column=3, padx=5, sticky=tkinter.W)
        tkinter.Radiobutton(self.top, text='Schneedecke', variable = self.iBesonders, value = 3, command=self.besonders).grid(row=3,column=3, padx=5, sticky=tkinter.W)
        tkinter.Button(self.top, text='OK', command=self.ok).grid(row=4, pady=10, column=0)
        tkinter.Button(self.top, text='Abbruch', command=self.abbruch).grid(row=4, pady=10, column=1)
    def ok(self):
        if (self.iWind.get() == 1): self.result = self.result + 1
        if (self.iWind.get() == 2): self.result = self.result + 2
        if (self.iWind.get() == 3): self.result = self.result + 3 
        if (self.iRegen.get() == 1): self.result = self.result + 4
        if (self.iRegen.get() == 2): self.result = self.result + 8
        if (self.iRegen.get() == 3): self.result = self.result + 12
        if (self.iWolken.get() == 1): self.result = self.result + 16
        if (self.iWolken.get() == 2): self.result = self.result + 32
        if (self.iWolken.get() == 3): self.result = self.result + 48
        if (self.iBesonders.get() == 1): self.result = self.result + 64
        if (self.iBesonders.get() == 2): self.result = self.result + 128
        if (self.iBesonders.get() == 3): self.result = self.result + 192   
        self.top.destroy()
    def wind(self):
        pass #print(self.iWind.get())
    def regen(self):
        pass #print(self.iRegen.get())
    def wolken(self):
        pass# print(self.iWolken.get())
    def besonders(self):
        pass# print(self.iBesonders.get())
    def abbruch(self):
        self.result = -1
        self.top.destroy()
        
